/*******************************************************************************
*
*  Web Vengeance Poo Pack - diaper.h
*
*  Header file for the Poo pack's Diaper Launcher effect.
*
*	Copyright (c) 1997 SegaSoft, Inc.  All Rights Reserved.
*
*------------------------------------------------------------------------------
*                   CONFIDENTIAL AND PROPRIETARY INFORMATION
*------------------------------------------------------------------------------
*  The contents of this file are the property of SegaSoft, Inc., 
*  and may not be used or duplicated without the permission of SegaSoft, Inc.
*------------------------------------------------------------------------------
*
*  Edit History:
*		97-Oct-29	DJS	Creation.
*
*  Initials:
*  	DJS	Dan J. Su
*
*******************************************************************************/
#ifndef DIAPER_H
#define DIAPER_H


#ifdef EXTERN
#undef EXTERN
#endif

#ifdef DEFINE_DIAPER
   #define EXTERN
#else
   #define EXTERN extern
#endif


// ---------- Structures and Types
typedef struct diaperSaveData_s
{
   int   x;                   // x-position for FXOBJECT
   int   y;                   // y-position for FXOBJECT
   int   iFrame;              // Set to one of two different final diaper textures:
                              // TEXTURE_SPLAT_A_5 or TEXTURE_SPLAT_B_5
} diaperSaveData_t;


// ---------- Defines
#define EFFECT_NAME_DIAPER    "Diaper"


// ---------- Function Prototypes
EXTERN BOOL DiaperUpdate      ( DDRAW_DATA *pDDrawData, int iEffect, int iMsg, int iObjectCount );
EXTERN BOOL DiaperDraw        ( DDRAW_DATA *pDDrawData, int iMsg );
EXTERN int  DiaperManualSave  ( DDRAW_DATA *pDDrawData, int iMsg, void *pvData );


// ---------- Global Variables



#endif   // DIAPER_H


