/*******************************************************************************
*
*  Web Vengeance Poo Pack - seagull.h
*
*  Header file for the Poo Pack's Seagull effect.
*
*	Copyright (c) 1997 SegaSoft, Inc.  All Rights Reserved.
*
*------------------------------------------------------------------------------
*                   CONFIDENTIAL AND PROPRIETARY INFORMATION
*------------------------------------------------------------------------------
*  The contents of this file are the property of SegaSoft, Inc., 
*  and may not be used or duplicated without the permission of SegaSoft, Inc.
*------------------------------------------------------------------------------
*
*  Edit History:
*		97-Sep-29	DJS	Creation.
*
*  Initials:
*  	DJS	Dan J. Su
*
*******************************************************************************/
#ifndef SEAGULL_H
#define SEAGULL_H


#ifdef EXTERN
#undef EXTERN
#endif

#ifdef DEFINE_SEAGULL
   #define EXTERN
#else
   #define EXTERN extern
#endif


// ---------- Structures and Types
typedef struct seagullSaveData_s
{
   int   x;                   // x-position for FXOBJECT
   int   y;                   // y-position for FXOBJECT
   int   iFrame;              // Set to one of three different final poop textures,
                              // TEXTURE_SPLAT_A_3, TEXTURE_SPLAT_B_3, or TEXTURE_SPLAT_C_3
	float fAngle;              // Angle of the splat, where 0 points to the right
} seagullSaveData_t;


// ---------- Defines
#define EFFECT_NAME_SEAGULL      "Seagull"


// ---------- Function Prototypes
EXTERN BOOL SeagullUpdate     ( DDRAW_DATA *pDDrawData, int iEffect, int iMsg, int iObjectCount );
EXTERN BOOL SeagullDraw       ( DDRAW_DATA *pDDrawData, int iMsg );
EXTERN int  SeagullManualSave ( DDRAW_DATA *pDDrawData, int iMsg, void *pvData );


// ---------- Global Variables



#endif   // SEAGULL_H


