#define FALLING		0x01
#define FIRING		0x01
#define	EXPLODING	0x02
#define	HIT			0x04
#define	FLAMING		0x08
#define LOCKED		0x08
#define BLOCKED		0x10
#define	WAITING		0x20
#define ERASE		0x40
#define RETRACTING	0x80
#define DONE		0x0100
#define NOPAINT		0x0200
#define PERMDRAW	0x0400	//Draw into the screen capture buffer
#define MOVING		0x0800
#define LOADED		0x1000
#define LOADING		0x2000



typedef struct _DEFENSE
{
	BYTE	byObjectAlive;   //Did the Object get blocked by the Defense
	float	fIncrX;			// incremetal valuie for X
	float	fIncrY;			// incremental value for Y
	int		nDestX;			// The destination for X
	int		nDestY;			// The destination for Y
	int		nCount;	// Counter for the legth of time defene is waiting
	int		nSpeed;  // Speed at which defense moves
	int		nFlags;			// Flags for use
	BYTE	byDefenseMoving;	// Is the Defense in motion or is it waiting
	BYTE	byDefenseBlocked; // The defense has blocked the weapon
	BYTE	byDefenseLocked; // Is the Defense Locked onto an Object
	POINT	ptDef;			// Location where the defenseive image was hit

	FXOBJECT fxObject;		// The defense Object Structure

} DEFENSE;

typedef struct  _MULTIOBJECTS
{

	BYTE	byID;
	float t;				//time
	float d;				//distance
	float g;				//Gravity/velocity
	float fIncrX;			// incremetal valuie for X
	float fIncrY;			// incremental value for Y
	int nStartY;			//Starting Point Y
	int nStartX;			//Starting Point X
	int nDestX;				//Ending Point X
	int nDestY;				//Ending Point Y
	int nTimeIncr;			//Sound wave associated (if any)
	int nFlags;
	int nDrawFlags;			// Used to set drawing Flags
	int nCount;		

	BYTE byObjectBlocked;   //Did the Object get blocked by the Defense
	BYTE byObjectAlive;		//Is the Object Alive (Must create one before using)
	union O
		{
		FXOBJECT *pfxObject;	//Pointer to an FXObject data
		FXOBJECT fxObject;
		};

	void *pvUser;

} MULTIOBJECT;


typedef struct _MULTIDRIPS
{
	BYTE byObjectAlive;
	BYTE byID;

	float t;
	float d;
	float g;
	float fIncrX;
	float fIncrY;

	int nStartX;
	int nStartY;

	int nFlags;

	union md
		{
		FXOBJECT *pfxObject;	//Pointer to an FXObject data
		FXOBJECT fxObject;
		};

} MULTIDRIP;


